"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Headquarters = void 0;
const Enums_1 = require("../../constant/Enums");
const ShipStatus_1 = require("./ShipStatus");
const DeconSystem_1 = require("../systems/DeconSystem");
const HudOverrideSystem_1 = require("../systems/HudOverrideSystem");
const LifeSuppSystem_1 = require("../systems/LifeSuppSystem");
const MedScanSystem_1 = require("../systems/MedScanSystem");
const ReactorSystem_1 = require("../systems/ReactorSystem");
const SabotageSystem_1 = require("../systems/SabotageSystem");
const SwitchSystem_1 = require("../systems/SwitchSystem");
class Headquarters extends ShipStatus_1.ShipStatus {
    constructor(stage, netid, data) {
        super(stage, netid, data);
        this.classname = "ShipStatus";
    }
    Deserialize(reader, spawn = false) {
        if (!this.systems) {
            this.systems = {
                [Enums_1.SystemType.Reactor]: new ReactorSystem_1.ReactorSystem(this),
                [Enums_1.SystemType.Electrical]: new SwitchSystem_1.SwitchSystem(this),
                [Enums_1.SystemType.O2]: new LifeSuppSystem_1.LifeSuppSystem(this),
                [Enums_1.SystemType.MedBay]: new MedScanSystem_1.MedScanSystem(this),
                [Enums_1.SystemType.Communications]: new HudOverrideSystem_1.HudOverrideSystem(this),
                [Enums_1.SystemType.Sabotage]: new SabotageSystem_1.SabotageSystem(this),
                [Enums_1.SystemType.Decontamination]: new DeconSystem_1.DeconSystem(this)
            };
        }
        this.DeserializeStep2(reader, spawn);
    }
}
exports.Headquarters = Headquarters;
Headquarters.classname = "ShipStatus";
