import { SystemType } from "../../constant/Enums";
import { DynamicBuffer } from "../../util/DynamicBuffer";
import { AutoDoorsSystem } from "../systems/AutoDoorsSystem";
import { DeconSystem } from "../systems/DeconSystem";
import { DoorsSystem } from "../systems/DoorsSystem";
import { HqHudSystem } from "../systems/HqHudSystem";
import { HudOverrideSystem } from "../systems/HudOverrideSystem";
import { LifeSuppSystem } from "../systems/LifeSuppSystem";
import { MedScanSystem } from "../systems/MedScanSystem";
import { ReactorSystem } from "../systems/ReactorSystem";
import { SabotageSystem } from "../systems/SabotageSystem";
import { SecurityCameraSystem } from "../systems/SecurityCameraSystem";
import { SwitchSystem } from "../systems/SwitchSystem";
import { Networkable } from "../Networkable";
import { Stage } from "../Stage";
declare type AllSystems = Partial<{
    [SystemType.Reactor]: ReactorSystem;
    [SystemType.Electrical]: SwitchSystem;
    [SystemType.O2]: LifeSuppSystem;
    [SystemType.MedBay]: MedScanSystem;
    [SystemType.Security]: SecurityCameraSystem;
    [SystemType.Communications]: HudOverrideSystem | HqHudSystem;
    [SystemType.Doors]: AutoDoorsSystem | DoorsSystem;
    [SystemType.Sabotage]: SabotageSystem;
    [SystemType.Decontamination]: DeconSystem;
    [SystemType.Decontamination2]: DeconSystem;
    [SystemType.Laboratory]: ReactorSystem;
}>;
export interface ShipStatusData {
    systems: AllSystems;
}
export declare class ShipStatus extends Networkable {
    static classname: "ShipStatus";
    classname: "ShipStatus";
    systems: AllSystems;
    constructor(stage: Stage, netid: number, data?: DynamicBuffer | ShipStatusData);
    Deserialize(reader: DynamicBuffer, spawn?: boolean): void;
    DeserializeStep2(reader: DynamicBuffer, spawn?: boolean): void;
    Serialize(writer: DynamicBuffer, spawn?: boolean): void;
}
export {};
