"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VoteBanSystem = void 0;
const Networkable_1 = require("../Networkable");
class VoteBanSystem extends Networkable_1.Networkable {
    constructor(stage, netid, data) {
        super(stage, netid, data);
        this.classname = "VoteBanSystem";
        this.clients = new Map;
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Deserialize(reader, spawn = false) {
        const num_players = reader.upacked();
        for (let i = 0; i < num_players; i++) {
            const clientid = reader.uint32();
            if (this.clients.get(clientid)) {
                this.clients.set(clientid, [null, null, null]);
            }
            const voters = this.clients.get(clientid);
            for (let i = 0; i < 3; i++) {
                voters[i] = reader.upacked();
            }
        }
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Serialize(writer, spawn = false) {
        writer.upacked(this.clients.size);
        for (const [clientid, voters] of this.clients) {
            writer.uint32(clientid);
            for (let i = 0; i < 3; i++) {
                writer.upacked(voters[i]);
            }
        }
    }
}
exports.VoteBanSystem = VoteBanSystem;
VoteBanSystem.classname = "VoteBanSystem";
