import { SystemType } from "../../constant/Enums";
import { DynamicBuffer } from "../../util/DynamicBuffer";
import { ShipStatus } from "../components/ShipStatus";
import { SystemStatus } from "./SystemStatus";
export declare enum DeconState {
    Enter = 1,
    Closed = 2,
    Exit = 4,
    HeadingUp = 8
}
export interface DeconSystemData extends SystemStatus {
    timer: number;
    state: number;
}
export declare class DeconSystem extends SystemStatus {
    static systemType: SystemType.Decontamination;
    systemType: SystemType.Decontamination;
    timer: number;
    state: number;
    constructor(ship: ShipStatus, data?: DynamicBuffer | DeconSystemData);
    Deserialize(reader: DynamicBuffer, spawn: boolean): void;
    Serialize(writer: DynamicBuffer, spawn: boolean): void;
}
