"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DoorsSystem = void 0;
const Enums_1 = require("../../constant/Enums");
const SystemStatus_1 = require("./SystemStatus");
class DoorsSystem extends SystemStatus_1.SystemStatus {
    constructor(ship, data) {
        super(ship, data);
        this.systemType = Enums_1.SystemType.Doors;
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Deserialize(reader, spawn) {
        const num_cooldown = reader.upacked();
        for (let i = 0; i < num_cooldown; i++) {
            const doorId = reader.uint8();
            const cooldown = reader.float();
            this.cooldowns.set(doorId, cooldown);
        }
        for (let i = 0; i < Enums_1.MapDoors.Polus; i++) {
            this.doors[i] = reader.bool();
        }
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Serialize(writer, spawn) {
        writer.upacked(this.cooldowns.size);
        for (const [doorId, cooldown] of this.cooldowns) {
            writer.uint8(doorId);
            writer.float(cooldown);
        }
        for (let i = 0; i < Enums_1.MapDoors.Polus; i++) {
            writer.bool(this.doors[i]);
        }
    }
}
exports.DoorsSystem = DoorsSystem;
DoorsSystem.systemType = Enums_1.SystemType.Doors;
