"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HqHudSystem = void 0;
const Enums_1 = require("../../constant/Enums");
const SystemStatus_1 = require("./SystemStatus");
class HqHudSystem extends SystemStatus_1.SystemStatus {
    constructor(ship, data) {
        super(ship, data);
        this.systemType = Enums_1.SystemType.Communications;
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Deserialize(reader, spawn) {
        const num_active = reader.upacked();
        this.active = [];
        for (let i = 0; i < num_active; i++) {
            const playerId = reader.uint8();
            const consoleId = reader.uint8();
            this.active.push({ playerId, consoleId });
        }
        const num_completed = reader.upacked();
        this.completed = [];
        for (let i = 0; i < num_completed; i++) {
            this.completed.push(reader.uint8());
        }
    }
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    Serialize(writer, spawn) {
        writer.upacked(this.active.length);
        for (let i = 0; i < this.active.length; i++) {
            const active = this.active[i];
            writer.uint8(active.playerId);
            writer.uint8(active.consoleId);
        }
        writer.upacked(this.completed.length);
        for (let i = 0; i < this.completed.length; i++) {
            writer.uint8(this.completed[i]);
        }
    }
}
exports.HqHudSystem = HqHudSystem;
HqHudSystem.systemType = Enums_1.SystemType.Communications;
