import { SystemType } from "../../constant/Enums";
import { DynamicBuffer } from "../../util/DynamicBuffer";
import { ShipStatus } from "../components/ShipStatus";
import { SystemStatus } from "./SystemStatus";
declare type SwitchSetup = [boolean, boolean, boolean, boolean, boolean];
export interface SwitchSystemData {
    expected: SwitchSetup;
    actual: SwitchSetup;
    brightness: number;
}
export declare class SwitchSystem extends SystemStatus {
    static systemType: SystemType.Electrical;
    systemType: SystemType.Electrical;
    expected: SwitchSetup;
    actual: SwitchSetup;
    brightness: number;
    constructor(ship: ShipStatus, data?: DynamicBuffer | SwitchSystemData);
    Deserialize(reader: DynamicBuffer, spawn: boolean): void;
    Serialize(writer: DynamicBuffer, spawn: boolean): void;
    static readSwitches(byte: number): SwitchSetup;
    static writeSwitches(switches: SwitchSetup): number;
}
export {};
