export declare class TextBuilder {
    private _str;
    constructor();
    get str(): string;
    /**
     * Write plain text.
     */
    text(str: string): this;
    /**
     * Create a text tag (color, link)
     */
    tag(content: string): this;
    /**
     * Set the text color.
     */
    color(hex: string): TextBuilder;
    color(r: number, g: number, b: number, a: number): TextBuilder;
    /**
     * Clear all styles (color, link).
     */
    clear(): this;
    /**
     * Write a clickable link.
     * @param url A URL to link to, must begin with http.
     */
    link(url: string): this;
}
