"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormatVersion = exports.FormatVersionInfo = exports.DecodeVersion = exports.EncodeVersion = exports.EncodeVersionInfo = void 0;
function EncodeVersionInfo(info) {
    return (info.year * 25000) +
        (info.month * 1800) +
        (info.day * 50) +
        info.revision;
}
exports.EncodeVersionInfo = EncodeVersionInfo;
function EncodeVersion(year, month, day, revision) {
    return EncodeVersionInfo({ year, month, day, revision });
}
exports.EncodeVersion = EncodeVersion;
function DecodeVersion(version) {
    const info = {};
    info.year = Math.floor(version / 25000);
    version %= 25000;
    info.month = Math.floor(version / 1800);
    version %= 1800;
    info.day = Math.floor(version / 50);
    info.revision = version % 50;
    return info;
}
exports.DecodeVersion = DecodeVersion;
function FormatVersionInfo(version) {
    if (typeof version === "number") {
        return FormatVersionInfo(DecodeVersion(version));
    }
    return version.year + "." + version.month + "." + version.day;
}
exports.FormatVersionInfo = FormatVersionInfo;
function FormatVersion(year, month, day, revision) {
    return year + "." + month + "." + day + "." + revision;
}
exports.FormatVersion = FormatVersion;
